-- RouteSplit.applescript
-- RouteSplit 1.4

--  Created by hany on 01/06/06.
--  Copyright 2006-2010 hanynet.com. All rights reserved.
--  www.hanynet.com/applications
-- BSD License applies.


on clicked theObject
	if the name of theObject is "start" then
		startRoute()
	else if the name of theObject is "stop" then
		stopRoute()
	else if the name of theObject is "showroutes" then
		showRoutes()
	else if the name of theObject is "install" then
		installStartup()
	else if the name of theObject is "remove" then
		removeStartup()
	else if the name of theObject is "about" then
		display window "about" attached to window "main"
	else if the name of theObject is "close" then
		close panel (window of theObject)
	else if the name of theObject is "closeroutes" then
		set the enabled of button "closeroutes" of window "routes" to false
		close panel (window of theObject)
		set the contents of text view "txt" of scroll view "txt" of window "routes" to "Please wait.."
	end if
end clicked

-- avvia route
on startRoute()
	addRouteShell()
	hideGUI()
end startRoute

-- stoppa route
on stopRoute()
	showGUI()
	delRouteShell()
end stopRoute

-- comando shell 
on addRouteShell()
	try
		set myGateway to the contents of text field "gateway" of window "main"
		set myNetwork to the contents of text field "network" of window "main"
		--display dialog ("/sbin/route add " & myNetwork & " " & myGateway)
		do shell script "/sbin/route add " & myNetwork & " " & myGateway with administrator privileges
	on error errorText
		display dialog ("RouteSplit Error: " & errorText) with icon 1
	end try
end addRouteShell

on delRouteShell()
	try
		set myGateway to the contents of text field "gateway" of window 1
		set myNetwork to the contents of text field "network" of window 1
		do shell script "/sbin/route delete " & myNetwork & " " & myGateway with administrator privileges
	on error errorText
		display dialog ("RouteSplit Error: " & errorText) with icon 1
	end try
end delRouteShell

-- nascondi campi e pulsante start
on hideGUI()
	set the enabled of text field "gateway" of window 1 to false
	set the enabled of text field "network" of window 1 to false
	set the enabled of button "start" of window 1 to false
	set the enabled of button "stop" of window 1 to true
end hideGUI

-- mostra campi e pulsante start
on showGUI()
	set the enabled of text field "gateway" of window 1 to true
	set the enabled of text field "network" of window 1 to true
	set the enabled of button "start" of window 1 to true
	set the enabled of button "stop" of window 1 to false
end showGUI

-- mostra finestra routing tables
on showRoutes()
	display window "routes" attached to window "main"
	set the contents of text view "txt" of scroll view "txt" of window "routes" to ""
	set the contents of text view "txt" of scroll view "txt" of window "routes" to do shell script "netstat -rn"
	set font of text view "txt" of scroll view "txt" of window "routes" to call method "fontWithName:size:" of class "NSFont" with parameters {"Monaco", 10}
	set the enabled of button "closeroutes" of window "routes" to true
end showRoutes

-- chiudi applicazione alla chiusura della finestra
on should quit after last window closed theObject
	quit
end should quit after last window closed

on installStartup()
	set myGateway to the contents of text field "gateway" of window 1
	set myNetwork to the contents of text field "network" of window 1
	set myPath to path to me as string
	set macPath to (myPath & "Contents:Resources:")
	set binaryPath to POSIX path of macPath
	try
		-- copia bash script routes.sh nella dir /etc
		do shell script "cp \"" & binaryPath & "routes.sh\" /etc/routes.sh" with administrator privileges
		-- rendi script eseguibile
		do shell script "chmod +x /etc/routes.sh" with administrator privileges
		-- copia file plist per avvio automatico di routes.sh con launchd in /Library
		do shell script "cp \"" & binaryPath & "net.routes.static.plist\" /Library/LaunchDaemons/net.routes.static.plist" with administrator privileges
		-- cambia id e gid del file plist 
		do shell script "chown root:wheel /Library/LaunchDaemons/net.routes.static.plist" with administrator privileges
		do shell script "launchctl load -w /Library/LaunchDaemons/net.routes.static.plist" with administrator privileges
		
		-- crea file di configurazione con gli indirizzi ip di gateway e destinazione per route
		do shell script "echo  " & myNetwork & " " & myGateway & " >/etc/routes.conf" with administrator privileges
	on error errorText
		display dialog ("RouteSplit Install Error: " & errorText)
	end try
	set the enabled of button "install" of window "main" to false
	set the enabled of button "remove" of window "main" to true
	display dialog ("Startup script installed. - Destination: " & myNetwork & " - Gateway: " & myGateway)
end installStartup

on removeStartup()
	try
		do shell script "rm -f /Library/LaunchDaemons/net.routes.static.plist" with administrator privileges
		do shell script "rm -f /etc/routes.conf" with administrator privileges
		do shell script "rm -f /etc/routes.sh" with administrator privileges
	on error errorText
		display dialog ("RouteSplit Install Error: " & errorText)
	end try
	set the enabled of button "install" of window "main" to true
	set the enabled of button "remove" of window "main" to true
	display dialog ("Startup script removed. Active routes has not been modified.  ")
end removeStartup



-- 




